app/apps/reporting/urls.py
from django.urls import path

from reporting.views import (ReportList, ReportDetail)

urlpatterns = [
    path('reports/', ReportList.as_view(), name='report-list'),
    path('reports/<int:pk>/', ReportDetail.as_view(), name='report-detail'),
]

app/escriptorium/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include
from django.views.generic import TemplateView

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('core.urls')),
    path('', include('users.urls')),
    path('', include('reporting.urls')),
    path('api/', include('api.urls', namespace='api')),
    path(r'captcha/', include('captcha.urls')),
]

if settings.DEBUG:
    try:
        import debug_toolbar
    except ImportError:
        pass
    else:
        urlpatterns += [path('__debug__/', include(debug_toolbar.urls)),]

    # simulates a 500 to test error logging
    from django.views.defaults import server_error
    urlpatterns += [path('500/', server_error),
                    path('404/', TemplateView.as_view(template_name='404.html'))]


    # Serve static files in developement
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

app/apps/reporting/models.py
from datetime import datetime, timezone

from django.contrib.auth import get_user_model
from django.db import models
from django.urls import reverse
from django.utils.translation import gettext_lazy as _

User = get_user_model()


class TaskReport(models.Model):
    WORKFLOW_STATE_QUEUED = 0
    WORKFLOW_STATE_STARTED = 1
    WORKFLOW_STATE_ERROR = 2
    WORKFLOW_STATE_DONE = 3
    WORKFLOW_STATE_CHOICES = (
        (WORKFLOW_STATE_QUEUED, _("Queued")),
        (WORKFLOW_STATE_STARTED, _("Running")),
        (WORKFLOW_STATE_ERROR, _("Crashed")),
        (WORKFLOW_STATE_DONE, _("Finished"))
    )

    workflow_state = models.PositiveSmallIntegerField(
        default=WORKFLOW_STATE_QUEUED,
        choices=WORKFLOW_STATE_CHOICES
    )
    label = models.CharField(max_length=256)
    messages = models.TextField(blank=True)

    queued_at = models.DateTimeField(auto_now_add=True)
    started_at = models.DateTimeField(null=True)
    done_at = models.DateTimeField(null=True)

    user = models.ForeignKey(User, on_delete=models.CASCADE)

    # celery task id
    task_id = models.CharField(max_length=64, blank=True, null=True)

    def append(self, text):
        self.messages += text + '\n'

    @property
    def uri(self):
        return reverse('report-detail', kwargs={'pk': self.pk})

    def start(self, task_id):
        self.task_id = task_id
        self.workflow_state = self.WORKFLOW_STATE_STARTED
        self.started_at = datetime.now(timezone.utc)
        self.save()

    def error(self, message):
        # unrecoverable error
        self.workflow_state = self.WORKFLOW_STATE_ERROR
        self.append(message)
        self.save()

        self.user.notify(_('%(task_label)s error!') % {'task_label': self.label},
                         level='danger',
                         links=[{'text': 'Report', 'src': self.uri}])

    def end(self, extra_links=None):
        self.workflow_state = self.WORKFLOW_STATE_DONE
        self.done_at = datetime.now(timezone.utc)
        self.save()

        links = extra_links or []
        if self.messages != '':
            links.append({'text': 'Report', 'src': self.uri})
        self.user.notify(_('%(task_label)s done!') % {'task_label': self.label},
                         level='success',
                         links=links)

app/apps/reporting/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic import ListView, DetailView

from reporting.models import TaskReport


class ReportList(LoginRequiredMixin, ListView):
    model = TaskReport
    paginate_by = 20

    def get_queryset(self):
        qs = super().get_queryset()
        return (qs.filter(user=self.request.user)
                .exclude(messages='')
                .order_by('-queued_at'))


class ReportDetail(LoginRequiredMixin, DetailView):
    model = TaskReport
    context_object_name = 'report'

    def get_queryset(self):
        qs = super().get_queryset()
        return qs.filter(user=self.request.user)

app/escriptorium/templates/reporting/taskreport_detail.html
{% extends "base.html" %}
{% load i18n static %}

{% block body %}
<div class="container">
    <div>{{ report.label }}</div>
    <div>{% trans "Status:" %} {{ report.get_workflow_state_display }}</div>
    <div>{% trans "Queued at:" %} {{ report.queued_at }}</div>
    {% if report.workflow_state > 0 %}<div>{% trans "Started at:" %} {{ report.queued_at }}</div>{% endif %}
    {% if report.workflow_state > 1 %}<div>{% trans "Ended at:" %} {{ report.done_at }}</div>{% endif %}
    <div class="jumbotron">{{ report.messages|linebreaks }}</div>
</div>
{% endblock %}

app/escriptorium/templates/reporting/taskreport_list.html
{% extends "base.html" %}
{% load i18n static %}

{% block body %}
<div class="container">
    <table class="table table-hover">
    {% for report in object_list %}
    <tr>
        <td>{{ report.label }}</td>
        <td>{{ report.get_workflow_state_display }}</td>
        <td>{{ report.queued_at }}</td>
        <td><a href="{% url 'report-detail' report.pk %}">{% trans "Details" %}</a></td>
    </tr>
    {% empty %}
    <tr><td>{% trans "You don't have any task report yet." %}</td></tr>
    {% endfor %}
    </table>
</div>
{% endblock %}